package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.Enumeration;

public class DefaultPoliciesPanel extends JPanel implements UpdateWindow
{
  String[] columnsNames = {"Rule", "Policy"};
  Object[][] data = {};
  Object[][] old_data = {};
  JTable m_tableView = null;
  JScrollPane m_scrollPane = null;

  protected static int m_rowHeightInitialValue = 24;
  protected InputService selectedService = null;

  public DefaultPoliciesPanel()
  {
	this.setLayout(new BorderLayout());
	doDisplayTable();
  }        
  public void doDisplayTable()
  {
	// Create a model of the data.
	TableModel dataModel = new AbstractTableModel() {
	public int getColumnCount() { return columnsNames.length; }
	public int getRowCount() { return data.length;}
	public Object getValueAt(int row, int col) {return data[row][col];}
	public String getColumnName(int column) {return columnsNames[column];}
	public Class getColumnClass(int c) {return getValueAt(0, c).getClass();}
	public boolean isCellEditable(int row, int col) {return false;}
	public void setValueAt(Object aValue, int row, int column) { data[row][column] = aValue; }
	};

	// Create the table
	m_tableView = new JTable(dataModel);
	m_tableView .setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	m_tableView.setRowHeight(InputServicesPanel.m_rowHeightInitialValue);
	m_scrollPane = new JScrollPane(m_tableView);
	this.add("Center", m_scrollPane);
  }      
  public void updateWindow()
  {
	data = new Object[3][2];
	data[0][0] = "Input";
	data[1][0] = "Output";
	data[2][0] = "Forward";
	data[0][1] = DefaultPolicy.getInputDefaultPolicy();
	data[1][1] = DefaultPolicy.getOutputDefaultPolicy();
	data[2][1] = DefaultPolicy.getForwardDefaultPolicy();

	// Avoid table blinking : verify data changed, and if not, don't update table.
	boolean differenceEncountered = false;
	if (data.length != old_data.length) differenceEncountered = true;
	if (! differenceEncountered)
	{
	  for(int i=0; i < data.length; i++)
	  {
		if (data[i].length != old_data[i].length) differenceEncountered = true;
		if (differenceEncountered) break;

		for (int j=0; j < data[i].length; j++)
		{
		  if (!(data[i][j].equals(old_data[i][j]))) differenceEncountered = true;
		  if (differenceEncountered) break;
		}
	  }
	}
	// No difference between new and old data, so nothing to do and return.
	if (! differenceEncountered) return;

	old_data = data;

	// Create a model of the data.
	TableModel dataModel = new AbstractTableModel() {
	public int getColumnCount() { return columnsNames.length; }
	public int getRowCount() { return data.length;}
	public Object getValueAt(int row, int col) {return data[row][col];}
	public String getColumnName(int column) {return columnsNames[column];}
	public Class getColumnClass(int c) {return getValueAt(0, c).getClass();}
	public boolean isCellEditable(int row, int col) {return false;}
	public void setValueAt(Object aValue, int row, int column) { data[row][column] = aValue; }
	};


	m_tableView.setModel(dataModel);
	m_tableView.getColumn("Policy").setCellRenderer(DefaultPolicy.getPolicyRenderer());
	m_tableView.sizeColumnsToFit(-1);

  }            
}
