package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.Enumeration;

public class MasqModulesPanel extends JPanel implements UpdateWindow, ActionListener
{
  String[] columnsNames = {"Available modules", "In use"};
  Object[][] data = {};
  Object[][] old_data = {};
  JTable m_tableView = null;
  JScrollPane m_scrollPane = null;

  protected static int m_rowHeightInitialValue = 24;
  protected InputService selectedService = null;

	private javax.swing.JPopupMenu m_jPopupMenu;
	private javax.swing.JMenuItem m_jMenuItemDeselect;
	private javax.swing.JMenuItem m_jMenuItemDisable;
	private javax.swing.JMenuItem m_jMenuItemEnable;
  public MasqModulesPanel()
  {
	this.setLayout(new BorderLayout());
	doDisplayTable();
  }          
public void actionPerformed(ActionEvent e)
{
	if (m_tableView.getSelectedRow() == -1) return;
	
	if (e.getSource().equals(m_jMenuItemDeselect))
	{
		m_tableView.clearSelection();
		return;
	}

	if (e.getSource().equals(m_jMenuItemEnable))
	{
		MasqModule selectedMasqModule = (MasqModule)data[m_tableView.getSelectedRow()][columnsNames.length];
		selectedMasqModule.mb_enabled = true;
		JFwadmin.getInstance().refreshPanels();
		return;
	}
	if (e.getSource().equals(m_jMenuItemDisable))
	{
		MasqModule selectedMasqModule = (MasqModule)data[m_tableView.getSelectedRow()][columnsNames.length];
		selectedMasqModule.mb_enabled = false;
		JFwadmin.getInstance().refreshPanels();
		return;
	}
}
  public void doDisplayTable()
  {
	// Create a model of the data.
	TableModel dataModel = new AbstractTableModel() {
	public int getColumnCount() { return columnsNames.length; }
	public int getRowCount() { return data.length;}
	public Object getValueAt(int row, int col) {return data[row][col];}
	public String getColumnName(int column) {return columnsNames[column];}
	public Class getColumnClass(int c) {return getValueAt(0, c).getClass();}
	public boolean isCellEditable(int row, int col) {if (col == 1) return true; return false;}
	public void setValueAt(Object aValue, int row, int column) { data[row][column] = aValue; }
	};

	// Create the table
	m_tableView = new JTable(dataModel);
	m_tableView .setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	m_tableView.setRowHeight(InputServicesPanel.m_rowHeightInitialValue);
  	m_tableView.addMouseListener(new MouseAdapter() {
	public void mouseClicked(MouseEvent e)
	{
		if (m_tableView.getSelectedRow() == -1) return;

		if ((e.getModifiers() & e.BUTTON3_MASK) != 0)
		{
		  getJPopupMenu().show(m_tableView, e.getX(), e.getY());
		}
	}
	});

  	m_scrollPane = new JScrollPane(m_tableView);
	this.add("Center", m_scrollPane);
  }            
/**
 * Insert the method's description here.
 * Creation date: (17/02/00 02:39:11)
 * @return javax.swing.JPopupMenu
 */
public JPopupMenu getJPopupMenu()
{
	if (m_jPopupMenu == null)
	{
		m_jPopupMenu = new JPopupMenu("Choose Action");
		m_jPopupMenu.setLabel("Choose Action");
		m_jMenuItemDeselect = new JMenuItem("Deselect");
		m_jMenuItemDeselect.addActionListener(this);
		m_jPopupMenu.add(m_jMenuItemDeselect);
		m_jMenuItemEnable = new JMenuItem("Enable");
		m_jMenuItemEnable.addActionListener(this);
		m_jPopupMenu.add(m_jMenuItemEnable);
		m_jMenuItemDisable = new JMenuItem("Disable");
		m_jMenuItemDisable.addActionListener(this);
		m_jPopupMenu.add(m_jMenuItemDisable);
	}
	return m_jPopupMenu;
}
  public void updateWindow()
  {
	  data = new Object[MasqModule.masqModulesVector.size()][columnsNames.length + 1];
	  for (int i=0; i < MasqModule.masqModulesVector.size(); i++)
	  {
	  	MasqModule mm = (MasqModule)MasqModule.masqModulesVector.elementAt(i);
	  	data[i][0] = mm.mstr_name;
	  	if (mm.mb_enabled)
	  		data[i][1] = "Yes";
	  	else
	  		data[i][1] = "No";
	  	data[i][2] = mm;
	  }

	// Avoid table blinking : verify data changed, and if not, don't update table.
	boolean differenceEncountered = false;
	if (data.length != old_data.length) differenceEncountered = true;
	if (! differenceEncountered)
	{
	  for(int i=0; i < data.length; i++)
	  {
		if (data[i].length != old_data[i].length) differenceEncountered = true;
		if (differenceEncountered) break;

		for (int j=0; j < data[i].length; j++)
		{
		  if (!(data[i][j].equals(old_data[i][j]))) differenceEncountered = true;
		  if (differenceEncountered) break;
		}
	  }
	}
	// No difference between new and old data, so nothing to do and return.
	if (! differenceEncountered) return;

	old_data = data;

	// Create a model of the data.
	TableModel dataModel = new AbstractTableModel() {
	public int getColumnCount() { return columnsNames.length; }
	public int getRowCount() { return data.length;}
	public Object getValueAt(int row, int col) {return data[row][col];}
	public String getColumnName(int column) {return columnsNames[column];}
	public Class getColumnClass(int c) {return getValueAt(0, c).getClass();}
	public boolean isCellEditable(int row, int col) {if (col == 1) return true; return false;}
	public void setValueAt(Object aValue, int row, int column) { data[row][column] = aValue; }
	};


	m_tableView.setModel(dataModel);
	m_tableView.sizeColumnsToFit(-1);

  }                        
}
