package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

import java.util.Vector;
 
public class PortForwardRule
{
	static Vector portForwardRulesVector = new Vector();
  	protected static boolean removedRules;

	public IPAddress m_localIpAddress;
	public IPAddress m_remoteIpAddress;
	public int mi_localPort;
	public int mi_remotePort;
	public java.lang.String mstr_protocol;
	protected boolean mb_isApplied;
/**
 * MasqModules constructor comment.
 */
public PortForwardRule(String prot, long la, int lp, long ra, int rp)
{
	mstr_protocol = prot;
	m_localIpAddress = new IPAddress(la);
	mi_localPort = lp;
	m_remoteIpAddress = new IPAddress(ra);
	mi_remotePort = rp;
}
public static boolean changesAreNotApplied()
{
  if (removedRules) return true;

  for (int i=0; i < portForwardRulesVector.size(); i++)
  {
	if(! ((PortForwardRule)portForwardRulesVector.elementAt(i)).mb_isApplied) return true;
  }

  return false;
}
public static PortForwardRule getPortFordwardRule(PortForwardRule pfr)
{
	for (int i=0; i < portForwardRulesVector.size(); i++)
	{
		PortForwardRule t = (PortForwardRule) portForwardRulesVector.elementAt(i);
		if (t.m_localIpAddress.getLong() == pfr.m_localIpAddress.getLong())
		if (t.m_remoteIpAddress.getLong() == pfr.m_remoteIpAddress.getLong())
		if (t.mi_localPort == pfr.mi_localPort)
		if (t.mi_remotePort == pfr.mi_remotePort)
		if (t.mstr_protocol.equals(pfr.mstr_protocol))
			return t;
	}
	return null;
}
public static void makeChangesApplied()
{
  removedRules = false;

  for (int i=0; i < portForwardRulesVector.size(); i++)
  {
	((PortForwardRule)portForwardRulesVector.elementAt(i)).mb_isApplied = true;
  }
}
public static void removePortForwardRule(PortForwardRule pfr)
{
	PortForwardRule toBeRemoved = PortForwardRule.getPortFordwardRule(pfr);
	if (toBeRemoved == null) return;

	PortForwardRule.portForwardRulesVector.remove(toBeRemoved);
	removedRules = true;
}
  public static void reset()
  {
	for (int i=0; i < portForwardRulesVector.size(); i++)
	{
	  if (((PortForwardRule)portForwardRulesVector.elementAt(i)).mb_isApplied) removedRules = true;
	}
	portForwardRulesVector.removeAllElements();
  }      
/**
 * Insert the method's description here.
 * Creation date: (2/23/00 6:07:08 PM)
 * @return java.lang.String
 */
public String toString()
{
	return "PORTFW : PROT[" + mstr_protocol + "] LADDR[" + m_localIpAddress + "] LPORT[" + mi_localPort + "] RADDR[" + m_remoteIpAddress + "] RPORT[" + mi_remotePort + "]";
}
}
