package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Enumeration;

public class SystemDialog extends JDialog implements ActionListener
{
  JPanel panel1 = new JPanel();
  JList interfacesJList = new JList();
  JLabel validateDataJLabel = new JLabel();
  JTextField ipAddressJTextField = new JTextField();
  JLabel jLabel1 = new JLabel();
  JLabel netMaskJLabel = new JLabel();
  JTextField netMaskJTextField = new JTextField();
  JLabel interfaceKindJLabel = new JLabel();
  JComboBox networkKindJComboBox = new JComboBox();
  JButton okJButton = new JButton();

  private JFwadmin m_fwadmin;

  private String oldSelectedInterface;
  private String selectedInterface;

  public SystemDialog(JFwadmin theFwadmin, String title, boolean modal)
  {
	super(theFwadmin, title, modal);
	m_fwadmin = theFwadmin;
	try
	{
	  jbInit();

	  String[] data = new String[IPInterface.interfacesHashtable.size()];
	  int dataIndex = 0;
	  for(Enumeration e = IPInterface.interfacesHashtable.elements(); e.hasMoreElements(); )
	  {
		data[dataIndex++] = ((IPInterface)e.nextElement()).getName();
	  }

	  networkKindJComboBox.addItem(IPFWConstants.networkKindInternet);
	  networkKindJComboBox.addItem(IPFWConstants.networkKindLocalNetwork);
	  networkKindJComboBox.addItem(IPFWConstants.networkKindLocalLoopback);
	  networkKindJComboBox.addItem(IPFWConstants.networkKindDMZ);

	  final JList interfacesJList = new JList(data);
	  interfacesJList.setBounds(15, 45, 87, 109);
	  interfacesJList.setBackground(Color.white);
	  panel1.add(interfacesJList);
	  selectedInterface = data[0];
	  displayInterface(selectedInterface);
	  interfacesJList.setSelectedIndex(0);
	  interfacesJList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	  MouseListener mouseListener = new MouseAdapter() {
		public void mouseReleased(MouseEvent e)
		{
		  selectedInterface = (String)interfacesJList.getSelectedValue();
		  displayInterface(selectedInterface);
		}
		public void mouseClicked(MouseEvent e)
		{
		  selectedInterface = (String)interfacesJList.getSelectedValue();
		  displayInterface(selectedInterface);
		}
	  };
	  interfacesJList.addMouseListener(mouseListener);
	}
	catch(Exception ex)
	{
	  ex.printStackTrace();
	}
  }      
  public  void actionPerformed(ActionEvent ae)
  {
	IPInterface ipi = (IPInterface)IPInterface.interfacesHashtable.get(selectedInterface);
	ipi.setKind((String)networkKindJComboBox.getSelectedItem());
	dispose();
  }  
  private void displayInterface(String interfaceName)
  {
	 if (interfaceName == null) return;
	 if (IPInterface.interfacesHashtable.size() == 0) return;
	 if (oldSelectedInterface != null)
	 {
	  IPInterface ipi = (IPInterface)IPInterface.interfacesHashtable.get(oldSelectedInterface);
	  ipi.setKind((String)networkKindJComboBox.getSelectedItem());
	 }
	 oldSelectedInterface = interfaceName;
	 IPInterface ipi = (IPInterface)IPInterface.interfacesHashtable.get(interfaceName);
	 ipAddressJTextField.setText(ipi.getAddress().toString());
	 netMaskJTextField.setText(ipi.getMask().toString());
	 networkKindJComboBox.setSelectedItem(ipi.getKind());
  }  
  void jbInit() throws Exception
  {
	setSize(380, 340);
	getContentPane().add(panel1);
	panel1.setLayout(null);

	validateDataJLabel.setText("Please verify configuration");
	validateDataJLabel.setBounds(16, 8, 247, 26);
	panel1.add(validateDataJLabel);

	interfaceKindJLabel.setText("Kind of network");
	interfaceKindJLabel.setBounds(118, 37, 210, 26);
	panel1.add(interfaceKindJLabel);

	networkKindJComboBox.setBounds(118, 61, 215, 28);
	panel1.add(networkKindJComboBox);

	jLabel1.setText("IP address");
	jLabel1.setBounds(118, 98, 210, 26);
	panel1.add(jLabel1);

	ipAddressJTextField.setBounds(118, 128, 215, 28);
	ipAddressJTextField.setEnabled(false);
	panel1.add(ipAddressJTextField);

	netMaskJLabel.setText("Network mask");
	netMaskJLabel.setBounds(118, 163, 210, 26);
	panel1.add(netMaskJLabel);

	netMaskJTextField.setBounds(118, 189, 215, 28);
	netMaskJTextField.setEnabled(false);
	panel1.add(netMaskJTextField);

	okJButton.setText("OK");
	okJButton.setBounds(95, 230, 190, 32);
	okJButton.addActionListener(this);
	panel1.add(okJButton);
  }  
}
